function _instanceof(b, a) {
    if (a != null && typeof Symbol !== "undefined" && a[Symbol.hasInstance]) {
        return !!a[Symbol.hasInstance](b)
    } else {
        return b instanceof a
    }
}

function _classCallCheck(a, b) {
    if (!_instanceof(a, b)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _defineProperties(d, b) {
    for (var a = 0; a < b.length; a++) {
        var c = b[a];
        c.enumerable = c.enumerable || false;
        c.configurable = true;
        if ("value" in c) {
            c.writable = true
        }
        Object.defineProperty(d, c.key, c)
    }
}

function _createClass(c, a, b) {
    if (a) {
        _defineProperties(c.prototype, a)
    }
    if (b) {
        _defineProperties(c, b)
    }
    return c
}
var DM78JsSDK = (function () {
    function b() {
        _classCallCheck(this, b);
        this.callbacks = {}
    }
    _createClass(b, [{
        key: "sendRequest",
        value: function c(i) {
            var h = i.url,
                m = i.params,
                l = i.success,
                g = i.error;
            var k = "dm-js://" + h;
            if (m) {
                k = k + "?" + this.encodeSearchParams(m)
            }
            this.callbacks[k] = {
                success: l,
                error: g
            };
            var j = document.createElement("iframe");
            j.style.width = "1px";
            j.style.height = "1px";
            j.style.display = "none";
            j.src = k;
            document.body.appendChild(j);
            setTimeout(function () {
                j.remove();
            }, 100);
        }
    }, {
        key: "handleRequest",
        value: function e(i) {
            var h = i.url,
                j = i.data,
                g = i.error;
            var k = this.callbacks[h];
            if (k != null) {
                if (j != null && k.success != null) {
                    k.success(j)
                } else {
                    if (g != null && k.error != null) {
                        k.error(g)
                    }
                }
                delete this.callbacks[h]
            }
        }
    }, {
        // 获取授权信息
        // 返回用户的 Token
        key: "getToken",
        value: function f(h) {
            var j = h.id,
                i = h.success,
                g = h.error;
            this.sendRequest({
                url: "getToken",
                params: {
                    app_id: j
                },
                success: i,
                error: g
            });
        }
    }, {
        // 获取用户信息（蛋趣联合登录）
        key: "getUserInfo",
        value: function d(h) {
            var j = h.id,
                i = h.success,
                g = h.error;
            this.sendRequest({
                url: "getUserInfo",
                params: {
                    app_id: j
                },
                success: i,
                error: g
            })
        }
    }, {
        // 获取手机的器件信息
        // 版本号，host，app 版本信息, safeAreaBottom
        key: "getDeviceInfo",
        value: function m(h) {
            var j = h.success,
                g = h.error;
            this.sendRequest({
                url: "getDeviceInfo",
                success: j,
                error: g
            });
        }
    }, {
        // 打开搜索页面: 
        // keyword: 搜索关键字      
        // type: 搜索类型，默认是 "post"    
        // case post       //:帖子(默认)；
        // case news       //:新闻；
        // case recommend  //:好帖推荐；
        // case review     //:评测；
        // case item       //:单品；
        // case series     //:系列；
        // case factory    //:厂商；
        // case user       //:用户
        key: "openSearchPage",
        value: function m(h) {
            var j = h.success,
                k = h.keyword,
                type = h.type,
                g = h.error;
            this.sendRequest({
                url: "openSearchPage",
                params: {
                    type: type,
                    keyword: k
                },
                success: j,
                error: g
            })
        }
    }, {
        // 评分 
        /// score 现在的分数
        /// cid 词条id
        key: "openAddScorePage",
        value: function m(h) {
            var j = h.success,
                cid = h.cid,
                score = h.score,
                g = h.error;
            this.sendRequest({
                url: "openAddScorePage",
                params: {
                    cid: cid,
                    score: score
                },
                success: j,
                error: g
            })
        }

    }, {
        /// 打开厂商新闻
        /// fid  厂商id 
        /// name 厂商名称
        key: "openFactoryNewsPage",
        value: function m(h) {
            var j = h.success,
                fid = h.fid,
                name = h.name,
                g = h.error;
            this.sendRequest({
                url: "openFactoryNewsPage",
                params: {
                    fid: fid,
                    name: name,
                },
                success: j,
                error: g
            })
        }

    }, {
        /// 词条评论  
        /// cid 词条id
        /// pid 评论id（回复评论的id）
        key: "openAddCTCommentPage",
        value: function m(h) {
            var j = h.success,
                cid = h.cid,
                pid = h.pid,
                g = h.error;
            this.sendRequest({
                url: "openAddCTCommentPage",
                params: {
                    cid: cid,
                    pid: pid,
                },
                success: j,
                error: g
            })
        }

    }, {
        // 打开词条详情页页面: 
        // id: 词条id
        // type: 厂商factory; 单品item; 系列series
        key: "openCtDetailPage",
        value: function m(h) {
            var j = h.success,
                id = h.id,
                type = h.type,
                g = h.error;
            this.sendRequest({
                url: "openCtDetailPage",
                params: {
                    id: id,
                    type: type
                },
                success: j,
                error: g
            })
        }
    }, {
        // 打开基础的原生页面: 
        // 目前支持的页面: 
        // 用户详情页面(type: uid)，
        // 帖子详情页面(type: tid),
        // 板块详情页(type: fid),
        // 话题详情页(type: topic)
        key: "openBaseNativePage",
        value: function m(h) {
            var j = h.success,
                id = h.id,
                type = h.type,
                g = h.error;
            this.sendRequest({
                url: "openBaseNativePage",
                params: {
                    id: id,
                    type: type
                },
                success: j,
                error: g
            })
        }
    }, {
        // 获取页面信息,
        // type: 厂商factory; 单品item; 系列series
        key: "getPageInfo",
        value: function m(h) {
            var j = h.success,
                g = h.error;
            
            this.sendRequest({
                url: "getPageInfo",
                success: j,
                error: g
            });
        }
    }, {
        // 跳转小程序
        // appid: 小程序appid; path: 小程序页面路径 
        key: "jumpMiniprogram",
        value: function m(h) {
            var j = h.success,
                p = h.path,
                appid = h.appid,
                g = h.error;
            this.sendRequest({
                url: "jumpMiniprogram",
                params: {
                    path: p,
                    id: appid
                },
                success: j,
                error: g
            })
        }
    }, {
        // 执行命令
        // reloadWebView: 重新加载 webview 
        // login: 重新登录
        key: "executeCommand",
        value: function m(h) {
            var j = h.success,
                cmd = h.cmd,
                g = h.error;
            this.sendRequest({
                url: "executeCommand",
                params: {
                    cmd: cmd
                },
                success: j,
                error: g
            })
        }
    }, {
        // 分享数据
        // uid: 作者id
        // pid: 删帖
        // isFavorite: 是否收藏
        // shareType: 单独分享类型
        key: "shareContent",
        value: function m(h) {
            var j = h.success,
                appid = h.appid,
                uid = h.uid,
                pid = h.pid,
                path = h.path,
                query = h.query,
                coverURL = h.coverURL,
                webURL = h.webURL,
                title = h.title,
                description = h.description,
                shareType = h.shareType,
                isFavorite = h.isFavorite,
                g = h.error;
            this.sendRequest({
                url: "shareContent",
                params: {
                    appid: appid,
                    uid: uid,
                    pid: pid,
                    path: path,
                    query: query,
                    coverURL: coverURL,
                    webURL: webURL,
                    title: title,
                    description: description,
                    shareType: shareType,
                    isFavorite: isFavorite
                },
                success: j,
                error: g
            })
        }
    }, {
        // 打开图片浏览器
        // 参数：url 当前打开图片的 url； index: 当前url在所有图片中的索引。
        // 通过
        key: "openPhotoBrowser",
        value: function m(h) {
            var j = h.success,
                u = h.urls,
                i = h.index,
                g = h.error;
            this.sendRequest({
                url: "openPhotoBrowser",
                params: {
                    urls: u,
                    index: i
                },
                success: j,
                error: g
            })
        }
    }, {
        key: "encodeSearchParams",
        value: function a(g) {
            var h = [];
            Object.keys(g).forEach(function (i) {
                var j = g[i];
                if (typeof j === "undefined") {
                    j = ""
                }
                h.push([i, encodeURIComponent(j)].join("="))
            });
            return h.join("&")
        }
    }, {
        // 返回按钮
        key: "dismiss",
        value: function m(h) {
            var j = h.success,
                g = h.error;
            this.sendRequest({
                url: "dismiss",
                success: j,
                error: g
            })
        }
    }, {
        // 添加评论
        // id : 要评论的id，placeholder：就是在编辑器里面显示的：回复xxx
        key: "addPostComment",
        value: function m(h) {
            var j = h.success,
                id = h.id,
                placeholder = h.placeholder,
                g = h.error;
            this.sendRequest({
                url: "addPostComment",
                params: {
                    id: id,
                    placeholder: placeholder
                },
                success: j,
                error: g
            })
        }
    }, {
        // 举报
        // # type （post：帖子；user：用户）
        // # id (帖子的pid或用户id)
        key: "report",
        value: function m(h) {
            var j = h.success,
                id = h.id,
                type = h.type,
                g = h.error;
            this.sendRequest({
                url: "report",
                params: {
                    id: id,
                    type: type
                },
                success: j,
                error: g
            })
        }
    }]);
    return b
})();
var DMSDK = new DM78JsSDK();